/* Lab 3
 * Camera class
 * Maintain Camera transformation for OpenGL
 * Methods 
 * 
 * Note: one strategy is to keep at, LookAt and up as
 * as primary data, and update them when moving, and 
 * then re-derive xc,yc,zc and d from them. This means
 * after each move you call computeCameraMatrix to refresh
 * xc,yc,zc and d
 */
 
public class Camera {
  
  // Parameters to define camera transformation
  PVector at, lookAt, up;
  // Components of camera transformation 
  PVector zc, xc, yc, d;
  
  // Default camera parameters
  public Camera( ) {
    at = new PVector( 0,0,300);
    lookAt = new PVector (width/2,height/2,0);
    up = new PVector (0,1,0); 
  }
 
  // Compute elements of camera matrix xc,yc,zc and d
  public void computeCameraMatrix () {
    // Temporary stub - use built-in camera until  
    camera(at.x, at.y, at.z, lookAt.x, lookAt.y, lookAt.z, up.x, up.y, up.z);

  }
 
 
// Apply camera matrix to the OpenGL transform matrix
// Uncomment this after computeCameraMatrix is complete
  public void setCameraMatrix ( ) {
//    beginCamera();
//      resetMatrix();
//      applyMatrix( xc.x, xc.y, xc.z, d.x, 
//                   yc.x, yc.y, yc.z, d.y,
//                   zc.x, zc.y, zc.z, d.z,
//                   0.0, 0.0, 0.0, 1 );
//    endCamera();
  }
  
// Move the camera forward s units
  public void forwardCamera(float s) {

  }

// Rotate the camera around camera axis (zc) 
// positive t radians
public void rollCamera(float t) {

  }
  
// Other methods as needed
    
}
